package blatt8vorlage;

public class Reference {
	private Node node;
	private int begin;
	private int end;
	
	public Reference(Node node, int begin, int end) {
		this.node = node;
		this.begin = begin;
		this.end = end;
	}

	public Node getNode() {
		return node;
	}

	public void setNode(Node node) {
		this.node = node;
	}

	public int getBegin() {
		return begin;
	}

	public void setBegin(int begin) {
		this.begin = begin;
	}

	public int getEnd() {
		return end;
	}
	
	public void setEnd(int end) {
		this.end = end;
	}
	
	public int getLength() {
		return end - begin + 1;
	}
	
	public String getSubstring(String text) {
		return text.substring(begin, end+1);
	}
	
	/**
	 * Canonize this reference.
	 */
	public void canonize(String text) {
		// TODO
	}
	
	
	
	/**
	 * Maybe useful for debugging
	 */
	public String toString(String text) {
		return node.getNodeString(text) + ",(" + begin + "," + end + ")";
	}
}
